include "scripting/messages.lua"

function mission_thread()
   sleep(1000)

   -- Initial messages
   local sea = map:get_field(28, 8)
   scroll_smoothly_to(sea,5)

   campaign_message_box(diary_page_1)
   sleep(400)

   -- Show the sea
   p1:reveal_fields(sea:region(5))
   local ship = p1:place_ship(sea)
   sleep(1000)
   campaign_message_box(diary_page_2)
   -- Hide the sea after 5 seconds
   run(function() sleep(5000) p1:hide_fields(sea:region(5)) end)

   -- Back home
   include "map:scripting/starting_conditions.lua"
   scroll_smoothly_to(sf)
   campaign_message_box(diary_page_3)
   ship:remove()

   sleep(400)

    campaign_message_box(saledus)
	sleep(100)
    campaign_message_box(amalea)
	sleep(100)
    campaign_message_box(saledus_1)
    local o = add_campaign_objective(obj_build_first_outpost)
    while #p1:get_buildings("empire_outpost") < 1 do sleep(3249) end
    o.done = true

   -- Outpost is completed now
   campaign_message_box(saledus_2)
   o = add_campaign_objective(obj_build_quarry)
   campaign_message_box(amalea_1)
   while #p1:get_buildings("empire_quarry") < 1 do sleep(3249) end
   o.done = true

   -- quarry is now build but we need more basic infrastructure
   campaign_message_box(amalea_2)
   o = add_campaign_objective(obj_build_sawmill_stonemason_and_lumberjacks)
   while not check_for_buildings(p1, { empire_lumberjacks_house = 1, empire_sawmill = 1, empire_stonemasons_house = 1})
      do sleep(2343) end
   o.done = true

   -- we need to discover more land and a port space
   
   campaign_message_box(amalea_3)
   o = add_campaign_objective(obj_lower_marble_column_demand)
   while not mv.windows.economy_options do sleep(2434) end
   o.done = true  
   sleep(25000)
   campaign_message_box(saledus_3)  
   o2 = add_campaign_objective(obj_find_port_space)
     local port = map:get_field(17, 17)
	 local fowned = nil
   while not fowned do
         if port.owner == p1 then
            fowned = 1
            break
         end
         sleep(3213)
	  end
      sleep(3213)
   o2.done = true
   

   -- Now we can build a port
   campaign_message_box(saledus_4)
   o1 = add_campaign_objective(obj_build_port_and_shipyard)
   campaign_message_box(amalea_4)
   o3 = add_campaign_objective(obj_produce_wheat)
   run(function()
   while not check_for_buildings(p1, { empire_port = 1, empire_shipyard =1 }) do sleep(2434) end
   campaign_message_box(diary_page_4)
   o1.done = true
   end)
   run(function()
   while sf.immovable:get_wares("wheat") < 50 do sleep(2434) end
   campaign_message_box(amalea_5)
   o3.done = true
   end)
   
   -- We need cloth for building ships
   while not o3.done == true do sleep(2434) end
   o4 = add_campaign_objective(obj_produce_cloth)
   while sf.immovable:get_wares("cloth") < 2 do sleep(2434) end
   o4.done = true
   
   -- now we should explore our little world
   while not o1.done == true do sleep(2434) end
   campaign_message_box(saledus_5)
   o5 = add_campaign_objective(obj_build_expedition_ports)
   campaign_message_box(amalea_6)
   o6 = add_campaign_objective(obj_produce_gold)
   run(function()
   while not check_for_buildings(p1, { empire_port = 3 }) do sleep(2434) end
   campaign_message_box(saledus_6)
   o7 = add_campaign_objective(obj_conquer_all)
   o5.done = true
   end)
   run(function()
   while sf.immovable:get_wares("gold") < 6 do sleep(2434) end
   o6.done = true
   end)
   while true do
      local barmil = p2:get_buildings{"barbarians_headquarters", "barbarians_warehouse", "barbarians_port"}
      if (#barmil.barbarians_headquarters + #barmil.barbarians_warehouse + #barmil.barbarians_port) < 1 then
         break
      end
      sleep(2342)
   end
   o7.done = true

   -- Everything done. Get home and defend the empire
   campaign_message_box(saledus_7)

   sleep(25000) -- Sleep a while

   campaign_message_box(diary_page_5)

end

run(mission_thread)

